@use 'shop/resources/scss/base/constants/colors';
@use 'shop/resources/scss/base/mixins/typography';

.primary {
    @include typography.text;

    display: inline-flex;
    flex-direction: row;
    justify-content: center;
    align-items: center;
    position: relative;
    background-color: colors.$color-primary;
    color: colors.$color-text;
    margin: 0 auto;
    border-color: colors.$color-primary;
    padding: 12px 16px;
    width: fit-content;

    &:hover {
        animation: slide-in 830ms;
        background: linear-gradient(to left, colors.$color-primary 50%, colors.$color-primary-dark 50%);
        background-size: 200% 100%;
    }
    &:active {
        background-color: colors.$color-primary;
        border-color: colors.$color-primary;
    }
    &:focus {
        outline-color: colors.$color-primary;
        background-color: colors.$color-primary-dark;
        box-shadow: 0 0 0 2px colors.$color-primary-dark;
    }
}

.secondary {
    @include typography.text;

    display: inline-flex;
    flex-direction: row;
    justify-content: center;
    align-items: center;
    position: relative;
    background-color: colors.$color-secondary;
    color: colors.$color-text;
    margin: 0 auto;
    border-color: colors.$color-secondary;
    padding: 12px 16px;
    width: fit-content;

    &:hover {
        animation: slide-in 830ms;
        background: linear-gradient(to left, colors.$color-secondary 50%, colors.$color-secondary-dark 50%);
        background-size: 200% 100%;
    }
    &:active {
        background-color: colors.$color-secondary;
        border-color: colors.$color-secondary;
    }
    &:focus {
        outline-color: colors.$color-secondary;
        background-color: colors.$color-secondary-dark;
        box-shadow: 0 0 0 2px colors.$color-secondary-dark;
    }
}

@keyframes slide-in {
    0% {
        background-position: right bottom;
    }

    100% {
        background-position: left bottom;
    }
}

.content {
    @include typography.text-ellipsis;

    display: inline-flex;
    transition: all 0.2s;
}

.icon {
    height: 27px;
    width: 27px;
}

.icon-after {
    margin-left: 12px;
}

.icon-before {
    margin-right: 12px;
}

.full-width {
    width: 100%;
}

.loading {
    animation: 0s linear 0.5s forwards make-visible;
    visibility: hidden;

    .content {
        opacity: 0;
        visibility: hidden;
    }

    &::after {
        content: '';
        position: absolute;
        width: 16px;
        height: 16px;
        top: 0;
        left: 0;
        right: 0;
        bottom: 0;
        margin: auto;
        border: 4px solid transparent;
        border-top-color: #ffffff;
        border-radius: 50%;
        animation: loading-spinner 1s ease infinite;
    }
}

@keyframes loading-spinner {
    from {
        transform: rotate(0turn);
    }

    to {
        transform: rotate(1turn);
    }
}

@keyframes make-visible {
    to {
        visibility: visible;
    }
}
